//
// Created by philipp on 12.02.18.
//

#ifndef CAR_PLATOONCONTROLLER_H
#define CAR_PLATOONCONTROLLER_H

#include <functional>

#include "PlatoonProtocolLib/Vehicle.h"
#include "PC2CarLib/CommandReceiver.h"
#include "EgoMotion.h"

namespace car
{

class PlatoonController
{
public:
    using Callback = std::function<void()>;
    
    PlatoonController(platoonProtocol::Vehicle::Ptr c2c,
                      pc2car::CommandReceiver::Ptr pc,
                      EgoMotion& egoMotion);
      
    void run();
    Callback cruiseControllerNotify;

private:

    platoonProtocol::Vehicle::Ptr c2c;
    pc2car::CommandReceiver::Ptr pc;
    EgoMotion& egoMotion;

};

}

#endif //CAR_PLATOONCONTROLLER_H
